/*
Techrm's calculator
created  July 2015
by Ricardo Medda and Giovanni Pintus
visit our blog http://techrm.blogspot.it/ or Instructables page http://www.instructables.com/member/techrm
*/

// include the library code:
#include <LiquidCrystal.h>
#include <TechrmKeypad.h>

#define key0 30
#define key1 31
#define key2 32
#define key3 33
#define key4 34
#define key5 35
#define key6 36
#define key7 37
#define key8 38
#define key9 39
#define DEL  28
#define ENTER 29

const long MAXVALUE = 99999;

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd_(12, 11, 5, 4, 3, 2);
// initialize the library with the names of the interface pins
TechrmKeypad keypad(key0, key1, key2, key3, key4, key5, key6, key7, key8, key9, DEL, ENTER);

long number_1_ = 0;
long number_2_ = 0;
int control_ = 0;
boolean error_ = false;
long result = 0;
float result_div = 0.0;

void setup() {
  // set up the lcd_'s number of columns and rows:
  lcd_.begin(16, 2);
}

//SUM function
long sum (long number_1_, long number_2_) {
  return number_1_ + number_2_;
}

//SUBtraction function
long subtraction (long number_1_, long number_2_) {
  return number_1_ - number_2_;
}

//MULtiplication function
long multiplication (long number_1_, long number_2_) {
  return number_1_ * number_2_;
}

//DIVision fucntion
float division (long number_1_, long number_2_) {
  return (float)number_1_ / (float)number_2_;
}

void loop() {
  number_1_ = 0;
  number_2_ = 0;
  delay (200);
  //asks which calculation you want to do
  lcd_.clear();
  lcd_.setCursor(0, 0);
  lcd_.print("SUM,SUB,MUL,DIV");
  lcd_.setCursor(0, 1);
  lcd_.print("0  ,1  ,2  ,3  ");

  //waits into the following loop till the user press a key
  keypad.wait();

  //"operation" is the variable needed to control the flow of the sketch
  int operation = keypad.readKey();
//SUM
  if (operation == 0) {
    keypad.insertNumb(&lcd_, &control_, &error_, &number_1_, &number_2_, &MAXVALUE);

    if (error_ == true) {
      lcd_.clear();
      lcd_.setCursor(0, 0);
      lcd_.print("DEL TO CONTINUE");
    }
    else {
      lcd_.clear();
      lcd_.setCursor(0, 0);
      lcd_.print("DEL TO CONTINUE");
      lcd_.setCursor(0, 1);
      lcd_.print("SUM = ");
      lcd_.setCursor(7, 1);
      result = sum(number_1_, number_2_);
      //check if the result is greater than MAXVALUE printing an error if yes
      if (result < MAXVALUE) {
        lcd_.print(result);
      } else {
        lcd_.clear();
        lcd_.setCursor(0, 0);
        lcd_.print("ERROR!");
        lcd_.setCursor(0, 1);
        lcd_.print("MAX VALUE " + (String)MAXVALUE);
        delay(4000);
        lcd_.clear();
        lcd_.setCursor(0, 0);
        lcd_.print("DEL TO CONTINUE");
      }
    }
    while (keypad.readKey() != 10);
  }
//SUBtraction  
  else if (operation == 1) {
    keypad.insertNumb(&lcd_, &control_, &error_, &number_1_, &number_2_, &MAXVALUE);
    if (error_ == true) {
      lcd_.clear();
      lcd_.setCursor(0, 0);
      lcd_.print("DEL TO CONTINUE");
    } else {
      lcd_.clear();
      lcd_.setCursor(0, 0);
      lcd_.print("DEL TO CONTINUE");
      lcd_.setCursor(0, 1);
      lcd_.print("SUB = ");
      lcd_.setCursor(7, 1);
      result = subtraction(number_1_, number_2_);
      //check if the result is greater than MAXVALUE printing an error if yes
      if (result < MAXVALUE) {
        lcd_.print(result);
      } else {
        lcd_.clear();
        lcd_.setCursor(0, 0);
        lcd_.print("ERROR!");
        lcd_.setCursor(0, 1);
        lcd_.print("MAX VALUE " + (String)MAXVALUE);
        delay(4000);
        lcd_.clear();
        lcd_.setCursor(0, 0);
        lcd_.print("DEL TO CONTINUE");
      }
    }
    while (keypad.readKey() != 10);
  }
//MULtiplication  
  else if (operation == 2) {
    keypad.insertNumb(&lcd_, &control_, &error_, &number_1_, &number_2_, &MAXVALUE);
    if (error_ == true) {

      lcd_.clear();
      lcd_.setCursor(0, 0);
      lcd_.print("DEL TO CONTINUE");

    } else {

      lcd_.clear();
      lcd_.setCursor(0, 0);
      lcd_.print("DEL TO CONTINUE");
      lcd_.setCursor(0, 1);
      lcd_.print("MUL = ");
      lcd_.setCursor(7, 1);
      result = multiplication(number_1_, number_2_);
      //check if the result is greater than MAXVALUE printing an error if yes
      if (result < MAXVALUE) {
        lcd_.print(result);
      } else {
        lcd_.clear();
        lcd_.setCursor(0, 0);
        lcd_.print("ERROR!");
        lcd_.setCursor(0, 1);
        lcd_.print("MAX VALUE " + (String)MAXVALUE);
        delay(4000);
        lcd_.clear();
        lcd_.setCursor(0, 0);
        lcd_.print("DEL TO CONTINUE");
      }
    }
    while (keypad.readKey() != 10);
  }
//DIVision  
  else if (operation == 3)  {
    keypad.insertNumb(&lcd_, &control_, &error_, &number_1_, &number_2_, &MAXVALUE);
    if (error_ == true) {
      lcd_.clear();
      lcd_.setCursor(0, 0);
      lcd_.print("DEL TO CONTINUE");
    } else {
      lcd_.clear();
      lcd_.setCursor(0, 0);
      lcd_.print("DEL TO CONTINUE");
      lcd_.setCursor(0, 1);
      lcd_.print("DIV = ");
      lcd_.setCursor(7, 1);
      result_div = division(number_1_, number_2_);
      //check if the result is greater than MAXVALUE printing an error if yes
      if (result < MAXVALUE) {
        lcd_.print(result_div, 7);
      } else {
        lcd_.clear();
        lcd_.setCursor(0, 0);
        lcd_.print("error!");
        lcd_.setCursor(0, 1);
        lcd_.print("MAX VALUE " + (String)MAXVALUE);
        delay(4000);
        lcd_.clear();
        lcd_.setCursor(0, 0);
        lcd_.print("DEL TO CONTINUE");
      }
    }
    while (keypad.readKey() != 10);
//none operation selected, it shows an alert!    
  } else {
    lcd_.clear();
    lcd_.setCursor(0, 0);
    lcd_.print("ERROR!");
    lcd_.setCursor(0, 1);
    lcd_.print("PRESS 0,1,2 or 3");
    delay(2000);
  }
  int  control_ = 0;
}
